import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import { TabsPage } from './tabs.page';

const routes: Routes = [
  {
    path: 'tabs',
    component: TabsPage,
    children: [
      { path: 'feed', loadChildren: '../feed/feed.module#FeedPageModule' },
      { path: 'uploader', loadChildren: '../uploader/uploader.module#UploaderPageModule' },
      { path: 'profile', loadChildren: '../pages/profile/profile.module#ProfilePageModule' },
      // { path: 'post/:id', loadChildren: '../post/post.module#PostPageModule' },
      // { path: 'edit-profile', loadChildren: '../edit-profile/edit-profile.module#EditProfilePageModule' },
    ]
  }
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class TabsPageRoutingModule {}
